/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The AppErrorCodes model module.
     * @module constant/AppErrorCodes
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>AppErrorCodes</code>.
     * @alias module:constants/AppErrorCodes
     * @class
     */
    var exports = Object.freeze({
        /*error_tech_diff*/
        SYSTEM_ERROR: '100',

        /*custom_field*/
        CUSTOM_FIELD_KEY_INVALID: '3142',
        CUSTOM_FIELD_VALUE_INVALID_LENGTH: '3160',
        CUSTOM_FIELD_VALUE_INVALID: '1052',
        CUSTOM_FIELDS_INVALID: '',

        /*pagination*/
        PAGE_SIZE_INVALID: '770',
        FROM_INDEX_INVALID: '1013',
        TO_INDEX_INVALID: '1014',
        QUERY_ID_INVALID: '769',

        /*customer*/
        FIRST_NAME_INVALID: '405',
        LAST_NAME_INVALID: '406',
        MIDDLE_NAME_INVALID: '407',
        DATE_OF_BIRTH_INVALID: '419',
        SSN_INVALID: '404',
        LOCALE_INVALID: '443',
        EMAIL_INVALID: '418',
        HOME_PHONE_INVALID: '415',
        WORK_PHONE_INVALID: '417',
        MOBILE_PHONE_INVALID: '416',
        CUSTOMER_ADDRESS_SEGMENT_MISSING: '746',
        CUSTOMER_ADDRESS_LINE1_INVALID: '408',
        CUSTOMER_ADDRESS_LINE2_INVALID: '409',
        CUSTOMER_ADDRESS_CITY_INVALID: '410',
        CUSTOMER_ADDRESS_STATE_INVALID: '411',
        CUSTOMER_ADDRESS_COUNTRY_INVALID: '414',
        CUSTOMER_ADDRESS_ZIP1_INVALID: '412',
        CUSTOMER_ADDRESS_ZIP2_INVALID: '413',
        CUSTOMER_REFERENCE_INVALID: '5002',
        CUSTOMER_STATUS_INVALID: '442',
        ID_CUSTOMER_INVALID: '441',
        COMMENTS_INVALID: '5161',
        GENDER_INVALID: '',

        /*customer_account*/
        CUSTOMER_ACCOUNT_HOLDER_NAME_INVALID: '5007',
        CUSTOMER_ACCOUNT_NICKNAME_INVALID: '5008',
        CUSTOMER_ACCOUNT_NUMBER_INVALID: '5009',
        CUSTOMER_ACCOUNT_ADDRESS_LINE1_INVALID: '5016',
        CUSTOMER_ACCOUNT_ADDRESS_LINE2_INVALID: '5017',
        CUSTOMER_ACCOUNT_ADDRESS_CITY_INVALID: '5018',
        CUSTOMER_ACCOUNT_ADDRESS_STATE_INVALID: '5019',
        CUSTOMER_ACCOUNT_ADDRESS_COUNTRY_INVALID: '5020',
        CUSTOMER_ACCOUNT_ADDRESS_ZIP1_INVALID: '5021',
        CUSTOMER_ACCOUNT_ADDRESS_ZIP2_INVALID: '5022',
        CUSTOMER_ACCOUNT_REFERENCE_INVALID: '5005',
        CURRENT_BALANCE_INVALID: '421',
        CURRENT_STATEMENT_BALANCE_INVALID: '422',
        MINIMUM_PAYMENT_DUE_INVALID: '423',
        PAST_AMOUNT_DUE_INVALID: '5014',
        PAYMENT_DUE_DATE_INVALID: '420',
        CUSTOMER_ACCOUNT_STATUS_INVALID: '5013',
        STATEMENT_DATE_INVALID: '5170',
        FORM_PARAM_CUSTOMER_ACCOUNT_NUMBER_INVALID: '5009',

        /*funding_account*/
        FUNDING_ACCOUNT_HOLDER_NAME_INVALID: '5024',
        FUNDING_ACCOUNT_NICKNAME_INVALID: '5030',
        FUNDING_ACCOUNT_NUMBER_MANDATORY: '750',
        FUNDING_ACCOUNT_NUMBER_INVALID: '750',
        FUNDING_ACCOUNT_ADDRESS_LINE1_INVALID: '5031',
        FUNDING_ACCOUNT_ADDRESS_LINE2_INVALID: '5032',
        FUNDING_ACCOUNT_ADDRESS_CITY_INVALID: '5033',
        FUNDING_ACCOUNT_ADDRESS_STATE_INVALID: '5034',
        FUNDING_ACCOUNT_ADDRESS_COUNTRY_INVALID: '5035',
        FUNDING_ACCOUNT_ADDRESS_ZIP1_INVALID: '5036',
        FUNDING_ACCOUNT_ADDRESS_ZIP2_INVALID: '5037',
        ABA_ROUTING_NUMBER_MANDATORY: '754',
        FUNDING_ACCOUNT_SUBTYPE_MANDATORY: '567',
        FUNDING_ACCOUNT_SUBTYPE_INVALID: '5026',
        EXPIRY_DATE_INVALID: '529',
        FUNDING_ACCOUNT_STATUS_INVALID: '5027',
        PAYMENT_CARD_CVV_NUMBER_INVALID: '5100',
        EXT_ISSUED_FUNDING_ACCOUNT_INVALID: '5023',
        ACCOUNT_HOLDER_TYPE_INVALID: '985',
        ERROR_FUND_ACCT_INVALID: '589',
        FORM_PARAM_FUNDING_ACCOUNT_NUMBER_INVALID: '5042',
        FORM_PARAM_FUNDING_ACCOUNT_STATUS_INVALID: '448',
        FORM_PARAM_FUNDING_ACCOUNT_SUBTYPE_INVALID: '5026',
        FORM_PARAM_FUNDING_ACCOUNT_ABA_ROUTING_NUMBER_INVALID: '5043',
        FORM_PARAM_FUNDING_ACCOUNT_TYPE_INVALID: '5025',

        /*payment*/
        PAYMENT_REFERENCE_INVALID: '574',
        PAYER_ID_INVALID: '932',
        AMOUNT_INVALID: '459',
        CARD_CVV_NUMBER_INVALID: '539',
        PAYMENT_DATE_INVALID: '457',
        PAYMENT_METHOD_INVALID: '429',
        FEE_AMOUNT_INVALID: '5039',
        FEE_TYPE_INVALID: '579',
        PAYMENT_SCHEDULE_TYPE_INVALID: '501',
        ID_FUNDING_ACCOUNT_INVALID: '582',
        ID_PAYMENT_INVALID: '575',
        INVALID_COMMENTS: '5161',
        RECURRING_PAYMENT_AMOUNT_TYPE_INVALID: '5038',
        PAYMENT_REQUEST_DATE_INVALID: '5413',
        TRANSACTION_TYPE_INVALID: '501',
        ERROR_SEGMENT_MISSING: '100',
        QUERY_PARAM_PAYMENT_STATUS_INVALID: '5040',
        PAYMENT_CONFIRMATION_NUMBER_INVALID: '583',
        PAYMENT_FROM_DATE_INVALID: '584',
        PAYMENT_TO_DATE_INVALID: '585',

        /*fee*/
        ID_FEE_INVALID: '575',

        /*payment_setup*/
        PAYMENT_SETUP_REFERENCE_INVALID: '574',
        PAYMENT_SETUP_AMOUNT_INVALID: '459',
        PAYMENT_SETUP_CARD_CVV_NUMBER_INVALID: '539',
        PAYMENT_SETUP_PAYMENT_METHOD_INVALID: '429',
        PAYMENT_SETUP_FEE_AMOUNT_INVALID: '5039',
        PAYMENT_SETUP_FEE_TYPE_INVALID: '579',
        ID_CUSTOMER_ACCOUNT_INVALID: '581',
        PAYMENT_SETUP_SCHEDULE_TYPE_INVALID: '501',
        PAYMENT_RECURRING_TYPE_INVALID: '576',
        PAYMENT_RECURRING_COUNT_INVALID: '577',
        PAYMENT_AMOUNT_TYPE_INVALID: '5038',
        PAYMENT_START_DATE_INVALID: '464',
        PAYMENT_END_DATE_INVALID: '466',
        PAYMENT_LIMIT_AMOUNT_INVALID: '1054',
        ID_PAYMENT_SETUP_INVALID: '575',
        PAYMENT_PLAN_ID_INVALID: '675',
        PAYMENT_DEFER_DAYS_INVALID: '5414',
        QUERY_PARAM_PAYMENT_SETUP_STATUS_INVALID: '5040',
        PAYMENT_SETUP_CONFIRMATION_NUMBER_INVALID: '583',
        PAYMENT_SETUP_FROM_DATE_INVALID: '584',
        PAYMENT_SETUP_TO_DATE_INVALID: '585',

        /*refund*/
        PAYMENT_ID_INVALID: '1040',
        CUSTOMER_ID_INVALID: '759',
        REFUND_AMOUNT_INVALID: '1039',
        REFUND_TYPE_INVALID: '1038',
        REFUND_REFERENCE_INVALID: '574',
        REFUND_STATUS_INVALID: '',

        /*InvocationContext*/
        CLIENT_KEY_INVALID: '5418',
        REQUESTOR_INVALID: '5419',
        REQUESTOR_TYPE_INVALID: '5420',
        CHANNEL_INVALID: '5416',
        PRODUCT_INVALID: '5417',
        IDEMPOTENT_REQUEST_KEY_INVALID: '100',
        API_END_POINT_INVALID: '100',
        ATTRIBUTES_INVALID: '100',
        secret_INVALID: '100'
    });

    return exports;
}));
