/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The CustomerFilterEnum enum module.
     * @module enum/CustomerFilterEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>key</code> property while retrieving customers.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "customer_reference"
         * @const
         */
        "customer_reference": "customer_reference",
        /**
         * value: "account_number"
         * @const
         */
        "account_number": "account_number",
        /**
         * value: "ssn"
         * @const
         */
        "ssn": "ssn",
        /**
         * value: "email"
         * @const
         */
        "email": "email",
        /**
         * value: "page_size"
         * @const
         */
        "page_size": "page_size",
        /**
         * value: "query_id"
         * @const
         */
        "query_id": "query_id",
        /**
         * value: "from_index"
         * @const
         */
        "from_index": "from_index",
        /**
         * value: "to_index"
         * @const
         */
        "to_index": "to_index"
    });

    return exports;
}));