/**
 * Created by Alacriti Inc on 8/3/18.
 */
(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory();
    }
}(this, function () {
    'use strict';


    /**
     * The PaymentMethodEnum enum module.
     * @module enum/PaymentMethodEnum
     * @version 1.0.0
     */

    /**
     * Allowed values for the <code>payment_method</code> property.
     * @enum {String}
     * @readonly
     */
    var exports = Object.freeze({
        /**
         * value: "ach"
         * @const
         */
        "ach": "ach",
        /**
         * value: "check"
         * @const
         */
        "check": "check",
        /**
         * value: "visa_debit"
         * @const
         */
        "visa_debit": "visa_debit",
        /**
         * value: "pinless_debit"
         * @const
         */
        "pinless_debit": "pinless_debit",
        /**
         * value: "master_debit"
         * @const
         */
        "master_debit": "master_debit",
        /**
         * value: "amex_credit"
         * @const
         */
        "amex_credit": "amex_credit",
        /**
         * value: "discover_credit"
         * @const
         */
        "discover_credit": "discover_credit",
        /**
         * value: "visa_credit"
         * @const
         */
        "visa_credit": "visa_credit",
        /**
         * value: "master_credit"
         * @const
         */
        "master_credit": "master_credit",
        /**
         * value: "cash"
         * @const
         */
        "cash": "cash",
        /**
         * value: "discover_debit"
         * @const
         */
        "discover_debit": "discover_debit"
    });

    return exports;
}));