/**
 * Created by Alacriti Inc on 8/3/18.
 */
module.exports = {
    /**
     * The Address model constructor.
     * @property {module:model/base/Address}*/
    Address: require('./model/base/Address'),
    /**
     * The Attribute model constructor.
     * @property {module:model/base/Attribute}*/
    Attribute: require('./model/base/Attribute'),
    /**
     * The Attributes model constructor.
     * @property {module:model/base/Attributes}*/
    Attributes: require('./model/base/Attributes'),
    /**
     * The InvocationContext model constructor.
     * @property {module:model/base/InvocationContext}*/
    InvocationContext: require('./model/base/InvocationContext'),
    /**
     * The MultiMap model constructor.
     * @property {module:model/base/MultiMap}*/
    MultiMap: require('./model/base/MultiMap'),
    /**
     * The Customer model constructor.
     * @property {module:model/customer/Customer}*/
    Customer: require('./model/customer/Customer'),
    /**
     * The Customers model constructor.
     * @property {module:model/customer/Customers}*/
    Customers: require('./model/customer/Customers'),
    /**
     * The CustomerAccount model constructor.
     * @property {module:model/customeraccount/CustomerAccount}*/
    CustomerAccount: require('./model/customeraccount/CustomerAccount'),
    /**
     * The CustomerAccounts model constructor.
     * @property {module:model/customeraccount/CustomerAccounts}*/
    CustomerAccounts: require('./model/customeraccount/CustomerAccounts'),
    /**
     * The Error model constructor.
     * @property {module:model/error/Error}*/
    Error: require('./model/error/Error'),
    /**
     * The FundingAccount model constructor.
     * @property {module:model/fundingaccount/FundingAccount}*/
    FundingAccount: require('./model/fundingaccount/FundingAccount'),
    /**
     * The FundingAccounts model constructor.
     * @property {module:model/fundingaccount/FundingAccounts}*/
    FundingAccounts: require('./model/fundingaccount/FundingAccounts'),
    /**
     * The FeePayment model constructor.
     * @property {module:model/feepayment/FeePayment}*/
    FeePayment: require('./model/feepayment/FeePayment'),
    /**
     * The Fee model constructor.
     * @property {module:model/payment/Fee}*/
    Fee: require('./model/payment/Fee'),
    /**
     * The Payment model constructor.
     * @property {module:model/payment/Payment}*/
    Payment: require('./model/payment/Payment'),
    /**
     * The Payments model constructor.
     * @property {module:model/payment/Payments}*/
    Payments: require('./model/payment/Payments'),
    /**
     * The PaymentSchedule model constructor.
     * @property {module:model/paymentsetup/PaymentSchedule}*/
    PaymentSchedule: require('./model/paymentsetup/PaymentSchedule'),
    /**
     * The PaymentSetup model constructor.
     * @property {module:model/paymentsetup/PaymentSetup}*/
    PaymentSetup: require('./model/paymentsetup/PaymentSetup'),
    /**
     * The PaymentSetups model constructor.
     * @property {module:model/paymentsetup/PaymentSetups}*/
    PaymentSetups: require('./model/paymentsetup/PaymentSetups'),
    /**
     * The Refund model constructor.
     * @property {module:model/refund/Refund}*/
    Refund: require('./model/refund/Refund'),
    /**
     * The OrbipayApiException constructor.
     * @property {module:exception/OrbipayApiException}*/
    OrbipayApiException: require('./exception/OrbipayApiException'),
    /**
     * The ACHEligibleFlagEnum enum module.
     * @property {module:enum/ACHEligibleFlagEnum}
     */
    ACHEligibleFlagEnum: require('./enum/ACHEligibleFlagEnum'),
    /**
     * The ATMEligibleFlagEnum enum module.
     * @property {module:enum/ATMEligibleFlagEnum}
     */
    ATMEligibleFlagEnum: require('./enum/ATMEligibleFlagEnum'),
    /**
     * The CustomerAccountFilterEnum enum module.
     * @property {module:enum/CustomerAccountFilterEnum}
     */
    CustomerAccountFilterEnum: require('./enum/CustomerAccountFilterEnum'),
    /**
     * The CustomerAccountStatusEnum enum module.
     * @property {module:enum/CustomerAccountStatusEnum}
     */
    CustomerAccountStatusEnum: require('./enum/CustomerAccountStatusEnum'),
    /**
     * The CustomerFilterEnum enum module.
     * @property {module:enum/CustomerFilterEnum}
     */
    CustomerFilterEnum: require('./enum/CustomerFilterEnum'),
    /**
     * The FeeTypeEnum enum module.
     * @property {module:enum/FeeTypeEnum}
     */
    FeeTypeEnum: require('./enum/FeeTypeEnum'),
    /**
     * The FundingAccountFilterEnum enum module.
     * @property {module:enum/FundingAccountFilterEnum}
     */
    FundingAccountFilterEnum: require('./enum/FundingAccountFilterEnum'),
    /**
     * The FundingAccountHolderTypeEnum enum module.
     * @property {module:enum/FundingAccountHolderTypeEnum}
     */
    FundingAccountHolderTypeEnum: require('./enum/FundingAccountHolderTypeEnum'),
    /**
     * The FundingAccountStatusEnum enum module.
     * @property {module:enum/FundingAccountStatusEnum}
     */
    FundingAccountStatusEnum: require('./enum/FundingAccountStatusEnum'),
    /**
     * The FundingAccountSubtypeEnum enum module.
     * @property {module:enum/FundingAccountSubtypeEnum}
     */
    FundingAccountSubtypeEnum: require('./enum/FundingAccountSubtypeEnum'),
    /**
     * The FundingAccountTypeEnum enum module.
     * @property {module:enum/FundingAccountTypeEnum}
     */
    FundingAccountTypeEnum: require('./enum/FundingAccountTypeEnum'),
    /**
     * The GenderEnum enum module.
     * @property {module:enum/GenderEnum}
     */
    GenderEnum: require('./enum/GenderEnum'),
    /**
     * The InvocationModeEnum enum module.
     * @property {module:enum/InvocationModeEnum}
     */
    InvocationModeEnum: require('./enum/InvocationModeEnum'),
    /**
     * The PaymentAmountTypeEnum enum module.
     * @property {module:enum/PaymentAmountTypeEnum}
     */
    PaymentAmountTypeEnum: require('./enum/PaymentAmountTypeEnum'),
    /**
     * The PaymentFilterEnum enum module.
     * @property {module:enum/PaymentFilterEnum}
     */
    PaymentFilterEnum: require('./enum/PaymentFilterEnum'),
    /**
     * The PaymentMethodEnum enum module.
     * @property {module:enum/ACHEligibleFlagEnum}
     */
    PaymentMethodEnum: require('./enum/PaymentMethodEnum'),
    /**
     * The PaymentRecurringTypeEnum enum module.
     * @property {module:enum/PaymentRecurringTypeEnum}
     */
    PaymentRecurringTypeEnum: require('./enum/PaymentRecurringTypeEnum'),
    /**
     * The PaymentScheduleTypeEnum enum module.
     * @property {module:enum/PaymentScheduleTypeEnum}
     */
    PaymentScheduleTypeEnum: require('./enum/PaymentScheduleTypeEnum'),
    /**
     * The PaymentSetupFilterEnum enum module.
     * @property {module:enum/PaymentSetupFilterEnum}
     */
    PaymentSetupFilterEnum: require('./enum/PaymentSetupFilterEnum'),
    /**
     * The PaymentSetupScheduleTypeEnum enum module.
     * @property {module:enum/PaymentSetupScheduleTypeEnum}
     */
    PaymentSetupScheduleTypeEnum: require('./enum/PaymentSetupScheduleTypeEnum'),
    /**
     * The PaymentSetupStatusEnum enum module.
     * @property {module:enum/PaymentSetupStatusEnum}
     */
    PaymentSetupStatusEnum: require('./enum/PaymentSetupStatusEnum'),
    /**
     * The PaymentStatusEnum enum module.
     * @property {module:enum/PaymentStatusEnum}
     */
    PaymentStatusEnum: require('./enum/PaymentStatusEnum'),
    /**
     * The ProductEnum enum module.
     * @property {module:enum/ProductEnum}
     */
    ProductEnum: require('./enum/ProductEnum'),
    /**
     * The RefundStatusEnum enum module.
     * @property {module:enum/RefundStatusEnum}
     */
    RefundStatusEnum: require('./enum/RefundStatusEnum'),
    /**
     * The RefundTypeEnum enum module.
     * @property {module:enum/RefundTypeEnum}
     */
    RefundTypeEnum: require('./enum/RefundTypeEnum'),
    /**
     * The RequestorTypeEnum enum module.
     * @property {module:enum/RequestorTypeEnum}
     */
    RequestorTypeEnum: require('./enum/RequestorTypeEnum')
};
