/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('../model/CreateRefundRequest'), require('../model/ErrorResponseVO'), require('../model/RefundResponse'));
    }
}(this, function (ApiClient, CreateRefundRequest, ErrorResponseVO, RefundResponse) {
    'use strict';

    /**
     * Refund service.
     * @module swagger/api/RefundApi
     * @version 1.0.0
     */

    /**
     * Constructs a new RefundApi.
     * @alias module:swagger/api/RefundApi
     * @class
     * @param {module:swagger/ApiClient} [apiClient] Optional API client implementation to use,
     * default to {@link module:swagger/ApiClient#instance} if unspecified.
     */
    var exports = function (apiClient) {
        this.apiClient = apiClient || ApiClient.instance;


        /**
         * Callback function to receive the result of the createRefund operation.
         * @callback module:swagger/api/RefundApi~createRefundCallback
         * @param {String} error Error message, if any.
         * @param {module:swagger/model/RefundResponse} data The data returned by the service call.
         * @param {String} response The complete HTTP response.
         */

        /**
         * Create Refund
         * This API is used to initiate a refund. Any payment made using Orbipay can be refunded. Customer cannot initiate a refund request.  In other words, the Create Refund request will fail if the associated requestor_type is customer. The refund types that are supported in Orbipay are payment_and_fee, payment_only, fee_only, other. The amount is optional and needs to be specified only if it&#39;s a partial refund i.e., the refund type is other.
         * @param {String} channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels.
         * @param {String} clientKey The unique identifier assigned by Orbipay to the client.
         * @param {String} product The product identifier corresponding to the API.
         * @param {String} timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp.
         * @param {String} idempotentRequestKey The unique token sent by the client to identify the request. This is used to identify retrials and duplicate requests.
         * @param {String} requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor type. For customer, it would be the Orbipay generated customer id, for user, it would be the Orbipay user login id and for external user, it would be the client&#39;s external agent id. In the case of self registration, where there is no external identifier, the requestor can be set to &#39;guest&#39;.
         * @param {String} requestorType Type of the requestor of the API.
         * @param {String} ID_PAYMENT The unique identifier assigned by Orbipay to the payment.
         * @param {String} ID_CUSTOMER The unique identifier assigned by Orbipay to the customer.
         * @param {module:swagger/model/CreateRefundRequest} createRefundRequest JSON containing all the fields required to refund a payment.
         * @param {Object} opts Optional parameters
         * @param {String} opts.xOPAYHeaders Intended for the future use.
         * @param {module:swagger/api/RefundApi~createRefundCallback} callback The callback function, accepting three arguments: exception, data, response
         * data is of type: {@link module:swagger/model/RefundResponse}
         */
        this.createRefund = function (channel, clientKey, product, timestamp, idempotentRequestKey, requestor, requestorType, ID_PAYMENT, ID_CUSTOMER, createRefundRequest, opts, callback) {
            opts = opts || {};
            var postBody = createRefundRequest;

            var pathParams = {
                'ID_PAYMENT': ID_PAYMENT,
                'ID_CUSTOMER': ID_CUSTOMER
            };
            var queryParams = {};
            var collectionQueryParams = {};
            var headerParams = {
                'channel': channel,
                'client_key': clientKey,
                'product': product,
                'timestamp': timestamp,
                'idempotent_request_key': idempotentRequestKey,
                'requestor': requestor,
                'requestor_type': requestorType,
                'X-OPAY-Headers': opts['xOPAYHeaders']
            };
            var formParams = {};

            var authNames = [];
            var contentTypes = ['application/json'];
            var accepts = ['application/json'];
            var returnType = RefundResponse;

            return this.apiClient.callApi(
                '/customers/{ID_CUSTOMER}/payments/{ID_PAYMENT}/refunds', 'POST',
                pathParams, queryParams, collectionQueryParams, headerParams, formParams, postBody,
                authNames, contentTypes, accepts, returnType, callback
            );
        }
    };

    return exports;
}));
