/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('./CustomerAccountMinimalRequest'), require('./CustomerMinimalRequest'), require('./FeeRequest'), require('./FundingAccountMinimalRequest'), require('./PaymentScheduleVO'));
    }
}(this, function (ApiClient, CustomerAccountMinimalRequest, CustomerMinimalRequest, FeeRequest, FundingAccountMinimalRequest, PaymentScheduleVO) {
    'use strict';


    /**
     * The CreatePaymentSetupRequest model module.
     * @module swagger/model/CreatePaymentSetupRequest
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>CreatePaymentSetupRequest</code>.
     * @alias module:swagger/model/CreatePaymentSetupRequest
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>CreatePaymentSetupRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/CreatePaymentSetupRequest} obj Optional instance to populate.
     * @return {module:swagger/model/CreatePaymentSetupRequest} The populated <code>CreatePaymentSetupRequest</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('payment_setup_reference')) {
                obj['payment_setup_reference'] = ApiClient.convertToType(data['payment_setup_reference'], 'String');
            }
            if (data.hasOwnProperty('payment_setup_schedule_type')) {
                obj['payment_setup_schedule_type'] = ApiClient.convertToType(data['payment_setup_schedule_type'], 'String');
            }
            if (data.hasOwnProperty('amount')) {
                obj['amount'] = ApiClient.convertToType(data['amount'], 'String');
            }
            if (data.hasOwnProperty('card_cvv_number')) {
                obj['card_cvv_number'] = ApiClient.convertToType(data['card_cvv_number'], 'String');
            }
            if (data.hasOwnProperty('fee')) {
                obj['fee'] = FeeRequest.constructFromObject(data['fee']);
            }
            if (data.hasOwnProperty('customer')) {
                obj['customer'] = CustomerMinimalRequest.constructFromObject(data['customer']);
            }
            if (data.hasOwnProperty('funding_account')) {
                obj['funding_account'] = FundingAccountMinimalRequest.constructFromObject(data['funding_account']);
            }
            if (data.hasOwnProperty('customer_account')) {
                obj['customer_account'] = CustomerAccountMinimalRequest.constructFromObject(data['customer_account']);
            }
            if (data.hasOwnProperty('payment_schedule')) {
                obj['payment_schedule'] = PaymentScheduleVO.constructFromObject(data['payment_schedule']);
            }
            if (data.hasOwnProperty('comments')) {
                obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
            }
            if (data.hasOwnProperty('custom_fields')) {
                obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
            }
        }
        return obj;
    };

    /**
     * The unique identifier in the client system for the paymentSetup.
     * @member {String} payment_setup_reference
     */
    exports.prototype['payment_setup_reference'] = undefined;
    /**
     * The schedule type for the payment setup.
     * @member {module:swagger/model/CreatePaymentSetupRequest.PaymentSetupScheduleTypeEnum} payment_setup_schedule_type
     */
    exports.prototype['payment_setup_schedule_type'] = undefined;
    /**
     * The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     * @member {String} amount
     */
    exports.prototype['amount'] = undefined;
    /**
     * This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     * @member {String} card_cvv_number
     */
    exports.prototype['card_cvv_number'] = undefined;
    /**
     * @member {module:swagger/model/FeeRequest} fee
     */
    exports.prototype['fee'] = undefined;
    /**
     * @member {module:swagger/model/CustomerMinimalRequest} customer
     */
    exports.prototype['customer'] = undefined;
    /**
     * @member {module:swagger/model/FundingAccountMinimalRequest} funding_account
     */
    exports.prototype['funding_account'] = undefined;
    /**
     * @member {module:swagger/model/CustomerAccountMinimalRequest} customer_account
     */
    exports.prototype['customer_account'] = undefined;
    /**
     * @member {module:swagger/model/PaymentScheduleVO} payment_schedule
     */
    exports.prototype['payment_schedule'] = undefined;
    /**
     * @member {String} comments
     */
    exports.prototype['comments'] = undefined;
    /**
     * The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact support@billerpayments.com for more information on configuring and using custom fields.
     * @member {Object} custom_fields
     */
    exports.prototype['custom_fields'] = undefined;


    /**
     * Allowed values for the <code>payment_setup_schedule_type</code> property.
     * @enum {String}
     * @readonly
     */
    exports.PaymentSetupScheduleTypeEnum = {
        /**
         * value: "variable_recurring_enrollment"
         * @const
         */
        "variable_recurring_enrollment": "variable_recurring_enrollment",
        /**
         * value: "autopay_enrollment"
         * @const
         */
        "autopay_enrollment": "autopay_enrollment",
        /**
         * value: "payment_plan"
         * @const
         */
        "payment_plan": "payment_plan"
    };


    return exports;
}));


