/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'));
    }
}(this, function (ApiClient) {
    'use strict';


    /**
     * The CreateRefundRequest model module.
     * @module swagger/model/CreateRefundRequest
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>CreateRefundRequest</code>.
     * @alias module:swagger/model/CreateRefundRequest
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>CreateRefundRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/CreateRefundRequest} obj Optional instance to populate.
     * @return {module:swagger/model/CreateRefundRequest} The populated <code>CreateRefundRequest</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('refund_reference')) {
                obj['refund_reference'] = ApiClient.convertToType(data['refund_reference'], 'String');
            }
            if (data.hasOwnProperty('refund_type')) {
                obj['refund_type'] = ApiClient.convertToType(data['refund_type'], 'String');
            }
            if (data.hasOwnProperty('refund_amount')) {
                obj['refund_amount'] = ApiClient.convertToType(data['refund_amount'], 'String');
            }
            if (data.hasOwnProperty('comments')) {
                obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
            }
            if (data.hasOwnProperty('custom_fields')) {
                obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
            }
        }
        return obj;
    };

    /**
     * The unique identifier in the client system for the refund.
     * @member {String} refund_reference
     */
    exports.prototype['refund_reference'] = undefined;
    /**
     * The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.
     * @member {module:swagger/model/CreateRefundRequest.RefundTypeEnum} refund_type
     */
    exports.prototype['refund_type'] = undefined;
    /**
     * The refund amount upto 2 decimal places.
     * @member {String} refund_amount
     */
    exports.prototype['refund_amount'] = undefined;
    /**
     * @member {String} comments
     */
    exports.prototype['comments'] = undefined;
    /**
     * The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact support@billerpayments.com for more information on configuring and using custom fields.
     * @member {Object} custom_fields
     */
    exports.prototype['custom_fields'] = undefined;

    /**
     * Allowed values for the <code>refund_type</code> property.
     * @enum {String}
     * @readonly
     */
    exports.RefundTypeEnum = {
        /**
         * value: "payment_and_fee"
         * @const
         */
        "payment_and_fee": "payment_and_fee",
        /**
         * value: "payment_only"
         * @const
         */
        "payment_only": "payment_only",
        /**
         * value: "fee_only"
         * @const
         */
        "fee_only": "fee_only",
        /**
         * value: "other"
         * @const
         */
        "other": "other"
    };


    return exports;
}));


