/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('./AddressVO'), require('./CustomersCustomerAccountsResponse'), require('./CustomersFundingAccountsResponse'), require('./CustomersPaymentSetupsResponse'), require('./CustomersPaymentsResponse'));
    }
}(this, function (ApiClient, AddressVO, CustomersCustomerAccountsResponse, CustomersFundingAccountsResponse, CustomersPaymentSetupsResponse, CustomersPaymentsResponse) {
    'use strict';


    /**
     * The CustomerResponse model module.
     * @module swagger/model/CustomerResponse
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>CustomerResponse</code>.
     * @alias module:swagger/model/CustomerResponse
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>CustomerResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/CustomerResponse} obj Optional instance to populate.
     * @return {module:swagger/model/CustomerResponse} The populated <code>CustomerResponse</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('first_name')) {
                obj['first_name'] = ApiClient.convertToType(data['first_name'], 'String');
            }
            if (data.hasOwnProperty('last_name')) {
                obj['last_name'] = ApiClient.convertToType(data['last_name'], 'String');
            }
            if (data.hasOwnProperty('middle_name')) {
                obj['middle_name'] = ApiClient.convertToType(data['middle_name'], 'String');
            }
            if (data.hasOwnProperty('gender')) {
                obj['gender'] = ApiClient.convertToType(data['gender'], 'String');
            }
            if (data.hasOwnProperty('date_of_birth')) {
                obj['date_of_birth'] = ApiClient.convertToType(data['date_of_birth'], 'String');
            }
            if (data.hasOwnProperty('ssn')) {
                obj['ssn'] = ApiClient.convertToType(data['ssn'], 'String');
            }
            if (data.hasOwnProperty('locale')) {
                obj['locale'] = ApiClient.convertToType(data['locale'], 'String');
            }
            if (data.hasOwnProperty('email')) {
                obj['email'] = ApiClient.convertToType(data['email'], 'String');
            }
            if (data.hasOwnProperty('home_phone')) {
                obj['home_phone'] = ApiClient.convertToType(data['home_phone'], 'String');
            }
            if (data.hasOwnProperty('work_phone')) {
                obj['work_phone'] = ApiClient.convertToType(data['work_phone'], 'String');
            }
            if (data.hasOwnProperty('mobile_phone')) {
                obj['mobile_phone'] = ApiClient.convertToType(data['mobile_phone'], 'String');
            }
            if (data.hasOwnProperty('address')) {
                obj['address'] = AddressVO.constructFromObject(data['address']);
            }
            if (data.hasOwnProperty('customer_reference')) {
                obj['customer_reference'] = ApiClient.convertToType(data['customer_reference'], 'String');
            }
            if (data.hasOwnProperty('id')) {
                obj['id'] = ApiClient.convertToType(data['id'], 'String');
            }
            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'String');
            }
            if (data.hasOwnProperty('url')) {
                obj['url'] = ApiClient.convertToType(data['url'], 'String');
            }
            if (data.hasOwnProperty('customer_accounts')) {
                obj['customer_accounts'] = CustomersCustomerAccountsResponse.constructFromObject(data['customer_accounts']);
            }
            if (data.hasOwnProperty('funding_accounts')) {
                obj['funding_accounts'] = CustomersFundingAccountsResponse.constructFromObject(data['funding_accounts']);
            }
            if (data.hasOwnProperty('payments')) {
                obj['payments'] = CustomersPaymentsResponse.constructFromObject(data['payments']);
            }
            if (data.hasOwnProperty('payment_setups')) {
                obj['payment_setups'] = CustomersPaymentSetupsResponse.constructFromObject(data['payment_setups']);
            }
            if (data.hasOwnProperty('custom_fields')) {
                obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
            }
        }
        return obj;
    };

    /**
     * The first name of the customer.
     * @member {String} first_name
     */
    exports.prototype['first_name'] = undefined;
    /**
     * The last name of the customer.
     * @member {String} last_name
     */
    exports.prototype['last_name'] = undefined;
    /**
     * The middle name of the customer.
     * @member {String} middle_name
     */
    exports.prototype['middle_name'] = undefined;
    /**
     * The gender of the customer.
     * @member {module:swagger/model/CustomerResponse.GenderEnum} gender
     */
    exports.prototype['gender'] = undefined;
    /**
     * The date of birth of the customer. It should be in the full-date format as per ISO8601, namely, YYYY-MM-DD.
     * @member {String} date_of_birth
     */
    exports.prototype['date_of_birth'] = undefined;
    /**
     * The SSN of the customer if the account holder is an individual or the tax ID, if the customer is a business.
     * @member {String} ssn
     */
    exports.prototype['ssn'] = undefined;
    /**
     * The language in which the payee wants the alerts and notifications from Orbipay. This is to be specified in the format,<br><i>< <b>ISO-639-1 language code</b>  >_< <b>ISO ALPHA-2 Country Code</b> ></i>.<br> For e.g., <b>en_US</b> indicates the language preference as US English, which is also the default value.
     * @member {String} locale
     */
    exports.prototype['locale'] = undefined;
    /**
     * The email address of the customer.
     * @member {String} email
     */
    exports.prototype['email'] = undefined;
    /**
     * The home phone number of the customer.
     * @member {String} home_phone
     */
    exports.prototype['home_phone'] = undefined;
    /**
     * The work phone number of the customer.
     * @member {String} work_phone
     */
    exports.prototype['work_phone'] = undefined;
    /**
     * The mobile phone number of the customer.
     * @member {String} mobile_phone
     */
    exports.prototype['mobile_phone'] = undefined;
    /**
     * @member {module:swagger/model/AddressVO} address
     */
    exports.prototype['address'] = undefined;
    /**
     * The unique identifier in the client system for the customer.
     * @member {String} customer_reference
     */
    exports.prototype['customer_reference'] = undefined;
    /**
     * The unique identifier assigned by Orbipay to the customer.
     * @member {String} id
     */
    exports.prototype['id'] = undefined;
    /**
     * The status of the customer in Orbipay.
     * @member {module:swagger/model/CustomerResponse.StatusEnum} status
     */
    exports.prototype['status'] = undefined;
    /**
     * This URL fetches the Customer details.
     * @member {String} url
     */
    exports.prototype['url'] = undefined;
    /**
     * @member {module:swagger/model/CustomersCustomerAccountsResponse} customer_accounts
     */
    exports.prototype['customer_accounts'] = undefined;
    /**
     * @member {module:swagger/model/CustomersFundingAccountsResponse} funding_accounts
     */
    exports.prototype['funding_accounts'] = undefined;
    /**
     * @member {module:swagger/model/CustomersPaymentsResponse} payments
     */
    exports.prototype['payments'] = undefined;
    /**
     * @member {module:swagger/model/CustomersPaymentSetupsResponse} payment_setups
     */
    exports.prototype['payment_setups'] = undefined;
    /**
     * The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact support@billerpayments.com for more information on configuring and using custom fields.
     * @member {Object} custom_fields
     */
    exports.prototype['custom_fields'] = undefined;


    /**
     * Allowed values for the <code>gender</code> property.
     * @enum {String}
     * @readonly
     */
    exports.GenderEnum = {
        /**
         * value: "male"
         * @const
         */
        "male": "male",
        /**
         * value: "female"
         * @const
         */
        "female": "female"
    };

    /**
     * Allowed values for the <code>status</code> property.
     * @enum {String}
     * @readonly
     */
    exports.StatusEnum = {
        /**
         * value: "active"
         * @const
         */
        "active": "active",
        /**
         * value: "disabled"
         * @const
         */
        "disabled": "disabled",
        /**
         * value: "voluntary_cancellation"
         * @const
         */
        "voluntary_cancellation": "voluntary_cancellation",
        /**
         * value: "revoked"
         * @const
         */
        "revoked": "revoked",
        /**
         * value: "suspended"
         * @const
         */
        "suspended": "suspended",
        /**
         * value: "inactive"
         * @const
         */
        "inactive": "inactive"
    };


    return exports;
}));


