/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'));
    }
}(this, function (ApiClient) {
    'use strict';


    /**
     * The FeeRefund model module.
     * @module swagger/model/FeeRefund
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>FeeRefund</code>.
     * @alias module:swagger/model/FeeRefund
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>FeeRefund</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/FeeRefund} obj Optional instance to populate.
     * @return {module:swagger/model/FeeRefund} The populated <code>FeeRefund</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('fee_type')) {
                obj['fee_type'] = ApiClient.convertToType(data['fee_type'], 'String');
            }
            if (data.hasOwnProperty('fee_refund_amount')) {
                obj['fee_refund_amount'] = ApiClient.convertToType(data['fee_refund_amount'], 'String');
            }
        }
        return obj;
    };

    /**
     * The way the fee is being charged to the customer. Fee could be added to the amount being paid, or, it could be charged separately by the biller. The fee_type would default to add_to_principal if the fee is not configured for the client in Orbipay.
     * @member {module:swagger/model/FeeRefund.FeeTypeEnum} fee_type
     */
    exports.prototype['fee_type'] = undefined;
    /**
     * The fee amount upto 2 decimal places.
     * @member {String} fee_refund_amount
     */
    exports.prototype['fee_refund_amount'] = undefined;


    /**
     * Allowed values for the <code>fee_type</code> property.
     * @enum {String}
     * @readonly
     */
    exports.FeeTypeEnum = {
        /**
         * value: "add_to_principal"
         * @const
         */
        "add_to_principal": "add_to_principal",
        /**
         * value: "bill_separately"
         * @const
         */
        "bill_separately": "bill_separately"
    };


    return exports;
}));


