/**
 * Orbipay REST API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.6
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PaymentNetworkResponse model module.
   * @module swagger/model/PaymentNetworkResponse
   * @version 1.0.0
   */

  /**
   * Constructs a new <code>PaymentNetworkResponse</code>.
   * The response received either from ACH or Card networks.
   * @alias module:swagger/model/PaymentNetworkResponse
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>PaymentNetworkResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:swagger/model/PaymentNetworkResponse} obj Optional instance to populate.
   * @return {module:swagger/model/PaymentNetworkResponse} The populated <code>PaymentNetworkResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('payment_auth_code')) {
        obj['payment_auth_code'] = ApiClient.convertToType(data['payment_auth_code'], 'String');
      }
      if (data.hasOwnProperty('payment_response_code')) {
        obj['payment_response_code'] = ApiClient.convertToType(data['payment_response_code'], 'String');
      }
      if (data.hasOwnProperty('payment_response_msg')) {
        obj['payment_response_msg'] = ApiClient.convertToType(data['payment_response_msg'], 'String');
      }
    }
    return obj;
  };

  /**
   * The Auth Code returned by the card gateway. This is relevant only for card payments.
   * @member {String} payment_auth_code
   */
  exports.prototype['payment_auth_code'] = undefined;
  /**
   * The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments. OR The decline codes received from the card issuer or the card processor, in the event of declined card payments.
   * @member {String} payment_response_code
   */
  exports.prototype['payment_response_code'] = undefined;
  /**
   * The text describing the ACH return or the chargeback received from Visa/Mastercard, in the event of returned payments. OR The text describing the decline, from the card issuer or the card processor, in the event of declined card payments.
   * @member {String} payment_response_msg
   */
  exports.prototype['payment_response_msg'] = undefined;



  return exports;
}));


