/**
 * Orbipay Payments API
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.0.0
 * Contact: support@billerpayments.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.1
 *
 * Do not edit the class manually.
 *
 */

(function (root, factory) {
    if (typeof module === 'object' && module.exports) {
        // CommonJS-like environments that support module.exports, like Node.
        module.exports = factory(require('../ApiClient'), require('./AddressVO'));
    }
}(this, function (ApiClient, AddressVO) {
    'use strict';


    /**
     * The UpdateFundingAccountRequest model module.
     * @module swagger/model/UpdateFundingAccountRequest
     * @version 1.0.0
     */

    /**
     * Constructs a new <code>UpdateFundingAccountRequest</code>.
     * @alias module:swagger/model/UpdateFundingAccountRequest
     * @class
     */
    var exports = function () {
        var _this = this;
    };

    /**
     * Constructs a <code>UpdateFundingAccountRequest</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:swagger/model/UpdateFundingAccountRequest} obj Optional instance to populate.
     * @return {module:swagger/model/UpdateFundingAccountRequest} The populated <code>UpdateFundingAccountRequest</code> instance.
     */
    exports.constructFromObject = function (data, obj) {
        if (data) {
            obj = obj || new exports();

            if (data.hasOwnProperty('account_holder_name')) {
                obj['account_holder_name'] = ApiClient.convertToType(data['account_holder_name'], 'String');
            }
            if (data.hasOwnProperty('nickname')) {
                obj['nickname'] = ApiClient.convertToType(data['nickname'], 'String');
            }
            if (data.hasOwnProperty('address')) {
                obj['address'] = AddressVO.constructFromObject(data['address']);
            }
            if (data.hasOwnProperty('account_number')) {
                obj['account_number'] = ApiClient.convertToType(data['account_number'], 'String');
            }
            if (data.hasOwnProperty('aba_routing_number')) {
                obj['aba_routing_number'] = ApiClient.convertToType(data['aba_routing_number'], 'String');
            }
            if (data.hasOwnProperty('expiry_date')) {
                obj['expiry_date'] = ApiClient.convertToType(data['expiry_date'], 'String');
            }
            if (data.hasOwnProperty('account_holder_type')) {
                obj['account_holder_type'] = ApiClient.convertToType(data['account_holder_type'], 'String');
            }
            if (data.hasOwnProperty('account_subtype')) {
                obj['account_subtype'] = ApiClient.convertToType(data['account_subtype'], 'String');
            }
            if (data.hasOwnProperty('status')) {
                obj['status'] = ApiClient.convertToType(data['status'], 'String');
            }
            if (data.hasOwnProperty('card_cvv_number')) {
                obj['card_cvv_number'] = ApiClient.convertToType(data['card_cvv_number'], 'String');
            }
            if (data.hasOwnProperty('comments')) {
                obj['comments'] = ApiClient.convertToType(data['comments'], 'String');
            }
            if (data.hasOwnProperty('custom_fields')) {
                obj['custom_fields'] = ApiClient.convertToType(data['custom_fields'], 'Object');
            }
        }
        return obj;
    };

    /**
     * The name as specified on the account.
     * @member {String} account_holder_name
     */
    exports.prototype['account_holder_name'] = undefined;
    /**
     * The nickname by which a customer might want to identify the account.
     * @member {String} nickname
     */
    exports.prototype['nickname'] = undefined;
    /**
     * @member {module:swagger/model/AddressVO} address
     */
    exports.prototype['address'] = undefined;
    /**
     * The number or reference that a customer uses to identify the funding account.
     * @member {String} account_number
     */
    exports.prototype['account_number'] = undefined;
    /**
     * The ABA/Routing number for the bank account.
     * @member {String} aba_routing_number
     */
    exports.prototype['aba_routing_number'] = undefined;
    /**
     * The expiry date for the card. This is to be in the format MM/yy. Only applicable for cards accounts.
     * @member {String} expiry_date
     */
    exports.prototype['expiry_date'] = undefined;
    /**
     * The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.
     * @member {module:swagger/model/UpdateFundingAccountRequest.AccountHolderTypeEnum} account_holder_type
     */
    exports.prototype['account_holder_type'] = undefined;
    /**
     * The sub type of the funding account. This is derived by Orbipay in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account.
     * @member {module:swagger/model/UpdateFundingAccountRequest.AccountSubtypeEnum} account_subtype
     */
    exports.prototype['account_subtype'] = undefined;
    /**
     * The status of the funding account in Orbipay.
     * @member {module:swagger/model/UpdateFundingAccountRequest.StatusEnum} status
     */
    exports.prototype['status'] = undefined;
    /**
     * This is never returned by Orbipay. This needs to be passed to Orbipay when adding or editing a card funding account.
     * @member {String} card_cvv_number
     */
    exports.prototype['card_cvv_number'] = undefined;
    /**
     * @member {String} comments
     */
    exports.prototype['comments'] = undefined;
    /**
     * The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact support@billerpayments.com for more information on configuring and using custom fields.
     * @member {Object} custom_fields
     */
    exports.prototype['custom_fields'] = undefined;


    /**
     * Allowed values for the <code>account_holder_type</code> property.
     * @enum {String}
     * @readonly
     */
    exports.AccountHolderTypeEnum = {
        /**
         * value: "personal"
         * @const
         */
        "personal": "personal",
        /**
         * value: "business"
         * @const
         */
        "business": "business"
    };

    /**
     * Allowed values for the <code>account_subtype</code> property.
     * @enum {String}
     * @readonly
     */
    exports.AccountSubtypeEnum = {
        /**
         * value: "savings"
         * @const
         */
        "savings": "savings",
        /**
         * value: "checking"
         * @const
         */
        "checking": "checking",
        /**
         * value: "money_market"
         * @const
         */
        "money_market": "money_market",
        /**
         * value: "visa_credit"
         * @const
         */
        "visa_credit": "visa_credit",
        /**
         * value: "mastercard_credit"
         * @const
         */
        "mastercard_credit": "mastercard_credit",
        /**
         * value: "american_express_credit"
         * @const
         */
        "american_express_credit": "american_express_credit",
        /**
         * value: "discover_credit"
         * @const
         */
        "discover_credit": "discover_credit",
        /**
         * value: "visa_debit"
         * @const
         */
        "visa_debit": "visa_debit",
        /**
         * value: "mastercard_debit"
         * @const
         */
        "mastercard_debit": "mastercard_debit",
        /**
         * value: "discover_debit"
         * @const
         */
        "discover_debit": "discover_debit"
    };

    /**
     * Allowed values for the <code>status</code> property.
     * @enum {String}
     * @readonly
     */
    exports.StatusEnum = {
        /**
         * value: "active"
         * @const
         */
        "active": "active",
        /**
         * value: "inactive"
         * @const
         */
        "inactive": "inactive",
        /**
         * value: "frozen"
         * @const
         */
        "frozen": "frozen",
        /**
         * value: "deleted"
         * @const
         */
        "deleted": "deleted",
        /**
         * value: "suspended"
         * @const
         */
        "suspended": "suspended",
        /**
         * value: "unverified"
         * @const
         */
        "unverified": "unverified",
        /**
         * value: "unusable"
         * @const
         */
        "unusable": "unusable"
    };


    return exports;
}));


